BOFS/admin/views.py
from __future__ import absolute_import
from builtins import str
from flask import Blueprint, render_template, current_app, redirect, g, request, session, url_for, Response
from BOFS.globals import db, questionnaires, page_list
from BOFS.util import fetch_condition_count, display_time
from .util import sqlalchemy_to_json, verify_admin, escape_csv, questionnaire_name_and_tag
import json
from .QuestionnaireResults import *
from datetime import datetime
from os import path, listdir
from sqlalchemy.orm.attributes import InstrumentedAttribute


admin = Blueprint('admin', __name__, template_folder='templates', static_folder='static', url_prefix="/admin")


@admin.context_processor
def inject_template_vars():
    """
    Inject additional variables into the context of templates within this blueprint
    See http://flask.pocoo.org/docs/1.0/templating/#context-processors
    :return:
    """

    if "ADDITIONAL_ADMIN_PAGES" in current_app.config:
        additionalAdminPages = current_app.config['ADDITIONAL_ADMIN_PAGES']
    else:
        additionalAdminPages = None

    tableNames = []
    for t in db.metadata.tables:
        tableNames.append(t)

    questionnairesSystem = []

    if path.exists(current_app.root_path + "/questionnaires"):
        for q in listdir(current_app.root_path + "/questionnaires"):
            if q.endswith(".json"):
                questionnairesSystem.append(q.replace(".json", ""))

    tableNames = sorted(tableNames)
    questionnairesLive = current_app.page_list.get_questionnaire_list(True)
    questionnairesLiveUntagged = sorted(current_app.page_list.get_questionnaire_list())
    questionnairesSystem = sorted(questionnairesSystem)

    return dict(
        additionalAdminPages=additionalAdminPages,
        tableNames=tableNames,
        questionnairesLive=questionnairesLive,
        questionnairesLiveUntagged=questionnairesLiveUntagged,
        questionnairesSystem=questionnairesSystem,
        logGridClicks=current_app.config['LOG_GRID_CLICKS']
    )


@admin.route("/")
def admin_index():
    return redirect(url_for("admin.admin_login"))


@admin.route("/login", methods=['GET', 'POST'])
def admin_login():
    if session.get('loggedIn', False):
        return redirect(url_for("admin.route_progress"))

    if request.method == 'POST':
        if request.form['password'] != current_app.config['ADMIN_PASSWORD']:
            return render_template("login_admin.html", message="The password you entered is incorrect.")
        else:
            session['loggedIn'] = True
            session.modified = True

        return redirect(url_for("admin.route_progress"))
    else:
        return render_template("login_admin.html")


def fetch_progress():
    pages = current_app.page_list.flat_page_list()

    progress = db.session.query(db.Participant)

    for page in pages:
        if page['path'] in ["end", "consent"]:  # Don't show end page, use Participant.finished instead.
            pages.remove(page)
            continue

    for page in pages:
        pp = db.aliased(db.Progress, name=page['path'])
        progress = progress.outerjoin(pp, db.and_(
            pp.participantID == db.Participant.participantID,
            pp.path == page['path']
        )).add_entity(
            pp
        )

    progress = progress.all()
    return pages, progress


def fetch_progress_summary():
    summary_groups = db.session.query(
        db.Participant.condition,
        db.func.count(db.Participant.participantID).label('count'),
        db.func.sum(db.cast(db.Participant.is_abandoned, db.Integer)).label('countAbandoned'),
        db.func.sum(db.cast(db.Participant.is_in_progress, db.Integer)).label('countInProgress'),
        db.func.sum(db.cast(db.Participant.finished, db.Integer)).label('countFinished'),
        db.func.avg(db.Participant.duration).label('minutes')).\
        group_by(db.Participant.condition).all()

    summary = db.session.query(
        db.func.count(db.Participant.participantID).label('count'),
        db.func.sum(db.cast(db.Participant.is_abandoned, db.Integer)).label('countAbandoned'),
        db.func.sum(db.cast(db.Participant.is_in_progress, db.Integer)).label('countInProgress'),
        db.func.sum(db.cast(db.Participant.finished, db.Integer)).label('countFinished'),
        db.func.min(db.Participant.duration).label('minSeconds'),
        db.func.max(db.Participant.duration).label('maxSeconds'),
        db.func.avg(db.Participant.duration).label('seconds')).\
        one()

    return summary_groups, summary


@admin.route("/progress")
@verify_admin
def route_progress():
    pages, progress = fetch_progress()
    summary_groups, summary = fetch_progress_summary()

    return render_template("progress.html",
                           pages=pages, progress=progress,
                           summary_groups=summary_groups, summary=summary, display_time=display_time)


@admin.route("/progress_ajax")
@verify_admin
def route_progress_ajax():
    pages, progress = fetch_progress()
    return render_template("progress_ajax.html", pages=pages, progress=progress)


@admin.route("/progress_summary_ajax")
@verify_admin
def route_progress_summary_ajax():
    summary_groups, summary = fetch_progress_summary()
    return render_template("progress_summary_ajax.html",
                           summary_groups=summary_groups, summary=summary, display_time=display_time)


@admin.route("/export_item_timing")
@verify_admin
def route_export_item_timing():
    questionnaires = current_app.page_list.get_questionnaire_list(True)
    header = "participantID,mTurkID"
    output = ""

    headerComplete = False

    results = db.session.query(db.Participant).filter(db.Participant.finished == True).all()

    for p in results:
        output += str.format(u"{},\"{}\"", p.participantID, p.mTurkID.strip())

        for qName in questionnaires:
            tag = ""

            if '/' in qName:
                qNameParts = qName.split('/')
                qName = qNameParts[0]
                tag = qNameParts[1]

            q = p.questionnaire(qName, tag)
            logs = p.questionnaire_log(qName, tag)

            qNameFull = qName
            if len(tag) > 0:
                qNameFull = "{}_{}".format(qName, tag)

            for key in sorted(logs.keys()):
                if not headerComplete:
                    header += ",{}_{}".format(qNameFull, key)

                output += ",{}".format(logs[key])

        output += "\n"
        headerComplete = True

    return render_template("export_csv.html", data=str.format(u"{}\n{}", header, output))


# Builds the base query for exporting values in blueprint-defined tables
# To be used for each entry in the config's EXPORT
def create_export_base_queries(export_dict):
    table = getattr(db, export_dict['table'])

    levels = None
    filter = db.text(export_dict['filter'])
    groupBy = None
    orderBy = None

    if 'order_by' in export_dict and export_dict['order_by'] != '':
        orderBy = getattr(table, export_dict['order_by'])

    # determine how many columns to add to the export. If group_by is not used, then it's just one column
    if 'group_by' in export_dict and export_dict['group_by'] != '':
        levelsQ = db.session.query()

        if isinstance(export_dict['group_by'], list):
            groupBy = []
            for gb in export_dict['group_by']:
                groupBy.append(getattr(table, gb))
                levelsQ = levelsQ.add_columns(getattr(table, gb))
                levelsQ = levelsQ.group_by(getattr(table, gb))
        else:
            groupBy = getattr(table, export_dict['group_by'])
            levelsQ = levelsQ.add_columns(groupBy)
            levelsQ = levelsQ.group_by(groupBy)

        if orderBy:
            levelsQ = levelsQ.order_by(orderBy)

        levels = levelsQ.filter(filter).all()

    #pk = db.inspect(table).primary_key[0]
    baseQuery = db.session.query(table)

    if groupBy:
        if groupBy:
            if isinstance(groupBy, list):
                for gb in groupBy:
                    baseQuery = baseQuery.group_by(getattr(table, 'participantID'), gb)
            else:
                baseQuery = baseQuery.group_by(getattr(table, 'participantID'), groupBy)
    else:
        baseQuery = baseQuery.group_by(getattr(table, 'participantID'))

    if orderBy:
        baseQuery = baseQuery.order_by(orderBy)

    baseQuery = baseQuery.filter(filter)

    # Add the fields to the basequery
    for field in export_dict['fields']:
        if hasattr(table, field) and callable(getattr(table, field)):
            continue  # We can't include this python property as part of the query
        baseQuery = baseQuery.add_columns(db.literal_column(field))

    return levels, baseQuery


@admin.route("/export")
@admin.route("/export/download", endpoint="route_export_download")
@verify_admin
def route_export():
    unfinishedCount = db.session.query(db.Participant).filter(db.Participant.finished == False).count()  # For display only
    missingCount = 0
    innerJoins = db.session.query(db.Participant)  # Participants with complete data
    leftJoins = db.session.query(db.Participant)  # Participants with complete or incomplete data

    includeUnfinished = request.args.get('includeUnfinished', False)
    includeMissing = request.args.get('includeMissing', False)

    qList = page_list.get_questionnaire_list(include_tags=True)

    columns = dict()

    columns['participant'] = [
        "participantID",
        "mTurkID",
        "condition",
        "duration",
        "finished"
    ]

    calculatedColumns = dict()

    # First loop constructs the query and fetches the column names
    for qNameAndTag in qList:

BOFS/admin/templates/export.html
{% extends "template_admin.html" %}
{% block head %}
{% endblock %}

{% block content %}

    <form method="get">
        <div class="question padding">
            <ul class="form-check">
                <li>
                    <input type="checkbox" class="form-check-input" id="includeUnfinished" name="includeUnfinished" {{ "checked" if request.args.get('includeUnfinished', False) }}>
                    <label for="includeUnfinished">Include participants that did not complete the task (N={{unfinishedCount}})</label>
                </li>
                <li>
                    <input type="checkbox" class="form-check-input" id="includeMissing" name="includeMissing" {{ "checked" if request.args.get('includeMissing', False) }}>
                    <label for="includeMissing">Include participants that completed, but have missing data (N={{missingCount}})</label>
                </li>
            </ul>

            <button type="submit" class="btn btn-dark">Preview</button>
            <button type="submit" class="btn btn-dark" formaction="{{ url_for('admin.route_export_download') }}">Download CSV <i class="fas fa-file-csv"></i></button>
        </div>

        <p>Results for {{rowCount}} Participants</p>

        <div class="question">
            <div class="padding">
                <textarea style="width: 99%; height: 500px; white-space: pre;">{{ data | safe }}</textarea>
            </div>
        </div>

    </form>


{% endblock %}

BOFS/admin/templates/export_csv.html
{% extends "template_admin.html" %}
{% block head %}
{% endblock %}

{% block content %}

    <div class="question">
        <div class="padding">
            <textarea style="width: 99%; height: 500px; white-space: pre;">{{ data | safe }}</textarea>
        </div>
    </div>

{% endblock %}

BOFS/admin/templates/login_admin.html
{% extends "template.html" %}

{% block head %}
    <script>
        $(document).ready(function () {
            $("#password").jqxPasswordInput({ height: 25, width: 200, placeHolder: ""});
            $("#submit").jqxButton({ width: 60, height: 25 });
        });
    </script>
{% endblock %}
{% block content %}

    <form method="post">

        {% if message %}
            <i>{{ message }}</i>
        {% endif %}

        <div class="question">
            <div class="padding">
                <table style="margin: 0 auto;">
                    <tr>
                        <td style="padding-right: 10px;">Password:</td>
                        <td><input style="width: 200px;" type="password" name="password" id="password" /></td>
                        <td><input type="submit" id="submit" value="Login" /></td>
                    </tr>
                </table>
            </div>
        </div>
    </form>

{% endblock %}

BOFS/admin/templates/preview_questionnaire.html
{% extends "template_admin.html" %}
{% from "questionnaire_macro.html" import createQuestionnaire with context %}
{% block head %}
{% endblock %}

{% block content %}

    {% if (errors | length) > 0 %}
        <div class="error-box">
            <b>Errors were found</b>
            <ul>
                {% for e in errors %}
                <li>{{ e | safe }}</li>
                {% endfor %}
            </ul>
        </div>
    {% endif %}

    <form id="form">

    {{ createQuestionnaire(q) }}

    </form>

    <br>

    <div class="question padding">
        <h3>{{ q.title if q.title else "Questionnaire Metadata"}}</h3>

        <ul>
            <li><b>Reference:</b> {{ q.reference if q.reference }}</li>
            <li><b>DOI: </b> {{ ('<a href="{0}">{0}</a>'.format(q.doi) | safe if q.doi.startswith("http") else '<a href="https://doi.org/{0}">https://doi.org/{0}</a>'.format(q.doi) | safe) if q.doi }}</li>
        </ul>
    </div>
    {% if q.participant_calculations %}
    <div class="question padding">
        <h3>Per-Response Calculations</h3>

        <ul>
            {% for name, calc in q.participant_calculations.items() %}
            <li><b>{{ name }}</b>: <pre>{{ calc }}</pre></li>
            {% endfor %}
        </ul>
    </div>
    {% endif %}

{% endblock %}

BOFS/admin/templates/progress.html
{% extends "template_admin.html" %}
{% block head %}
{% endblock %}

{% block content %}


    {% include("progress_summary_ajax.html") %}


    <div class="question padding table-responsive">
        {% include("progress_ajax.html") %}
    </div>

    <script>
    setInterval(function() {
        $.ajax({
            url: "{{ url_for('admin.route_progress_ajax') }}",
            dataType: "html",
            success: function(data) {
                $("#progress").html(data);
            }
        });
        $.ajax({
            url: "{{ url_for('admin.route_progress_summary_ajax') }}",
            dataType: "html",
            success: function(data) {
                $("#summary").html(data);
            }
        });
    }, 15000);
    </script>

{% endblock %}

BOFS/admin/templates/progress_ajax.html
<table class="table table-striped" id="progress">
    <thead>
    <tr>
        <th scope="col" style="text-align: right; width: 50px;">PID</th>
        <th scope="col" style="text-align: left; width: 100px;">MTurk ID</th>
        <th scope="col" style="text-align: right; width: 70px;">Condition</th>
        <th scope="col" style="text-align: center; width: 110px;">Started On</th>
        {% for page in pages %}
            <th scope="col" style="text-align: center; width: 110px;">{{ page['path'].replace("/", " ").replace("_", " ") }}</th>
        {% endfor %}
        <th scope="col" style="text-align: center; width:50px;">Finished</th>
        <th scope="col" style="text-align: center; width:70px;">Time Taken</th>
    </tr>
    </thead>
    <tbody>
    {% for r in progress %}
        <tr>
            <td style="text-align: right">{{ r.Participant.participantID }}</td>
            <td style="text-align: left">{{ r.Participant.mTurkID }}</td>
            <td style="text-align: right">{{ r.Participant.condition }}</td>
            <td style="text-align: center">{{ r.Participant.timeStarted.strftime('%Y-%m-%d %H:%M:%S') }}</td>
            {% for page in pages %}
                <td style="text-align: center">
                    {% if r[page['path']] %}
                        {{ r[page['path']].display_duration() }}
                    {% endif %}
                </td>
            {% endfor %}
            <td style="text-align: center;">
                <input type="checkbox" disabled readonly {{ 'checked' if r.Participant.finished }}>
            </td>
            <td style="text-align: center;">{{ r.Participant.display_duration() }}</td>
        </tr>
    {% endfor %}
    </tbody>
</table>

BOFS/admin/templates/progress_summary_ajax.html
<div id="summary">
    <div style="display: flex; flex-wrap: wrap; margin-left: -15px;" >
        {% if 'CONDITIONS_NUM' in config and config['CONDITIONS_NUM'] > 1 %}
        <div class="question padding" style="flex-grow: 3; margin-left: 15px;">
            <table class="table table-striped">
                <thead>
                <tr>
                    <th scope="col" style="text-align: right; width: 50px;">Condition</th>
                    <th scope="col" style="text-align: center; width: 100px;">Count</th>
                    <th scope="col" style="text-align: center; width: 100px;">In Progress</th>
                    <th scope="col" style="text-align: center; width: 100px;">Abandoned</th>
                    <th scope="col" style="text-align: center; width: 100px;">Finished</th>
                    <th scope="col" style="text-align: center; min-width: 70px;">Time Taken</th>
                </tr>
                </thead>
                <tbody>
                {% for r in summary_groups %}
                    <tr>
                        <td style="text-align: left">{{ r.condition }}</td>
                        <td style="text-align: right">{{ r.count }}</td>
                        <td style="text-align: right">{{ r.countInProgress }}</td>
                        <td style="text-align: right">{{ r.countAbandoned }}</td>
                        <td style="text-align: right">{{ r.countFinished }}</td>
                        <td style="text-align: right">{{ display_time(r.minutes)  }}</td>
                    </tr>
                {% endfor %}
                </tbody>
            </table>
        </div>
        {% endif %}
        <div class="question padding" style="margin-left: 15px; flex-grow: 2">

            <div style="display: flex">
                <div style="flex-grow: 1;">
                    <h3>Summary</h3>
                    <div style="display: grid; grid-template-columns: 160px auto;">
                        <b>Total Participants</b> <span>{{ summary.count }}</span>
                        <b>In Progress</b> <span>{{ summary.countInProgress }}</span>
                        <b>Abandoned</b> <span>{{ summary.countAbandoned }}</span>
                        <b>Finished</b> <span>{{ summary.countFinished }}</span>
                    </div>
                </div>
                <div style="flex-grow: 1; margin-left: 15px;">
                    <div style="flex-grow: 1;">
                    <h3>Completion Time</h3>
                    <div style="display: grid; grid-template-columns: 120px auto;">
                        <b>Average</b> <span>{{ display_time(summary.seconds) }}</span>
                        <b>Minimum</b> <span>{{ display_time(summary.minSeconds) }}</span>
                        <b>Maximum</b> <span>{{ display_time(summary.maxSeconds) }}</span>
                    </div>
                </div>
                </div>
            </div>
        </div>
    </div>
</div>

BOFS/admin/templates/questionnaire_results.html
{% extends "template_admin.html" %}
{% block head %}
        <script type="text/javascript" language="javascript" src="{{ url_for('BOFS_static', filename='js/plotly-latest.min.js') }}"></script>
        <script type="text/javascript">
        $(document).ready(function () {


            //$('#tabRadioGrid').jqxTabs({ width: '930', height: 734, position: 'top'});

            // This dict is created in python and converted using json dumps.
            {% for key, gpd in gridPlotData.iteritems() %}
            var gpd_{{ key }} = {{ gpd | safe }};
            {% endfor %}

            var data = {{ gridPlotJSVars | safe }};

            var chartLayout = {barmode: 'group'};

            Plotly.newPlot('chartRadioGrid', data, chartLayout);

        });
        </script>
{% endblock %}

{% block content %}

    <div class="question">
        <div class="padding" style="overflow: auto; font-size: 9pt;">

            <b style="font-size: 12pt">{{ questionnaireName }} {{ " - " + tag if tag != 0 }}</b>

            <div id="tabRadioGrid">

                <div>
                    <div style="padding: 10px;">
                        <br>
                        <table style="width: 100%; border: 1px solid black; border-collapse: collapse;" border="1">
                            <tr>
                                <td><b>Subscale</b></td>
                                <td><b>Condition</b></td>
                                <td><b>N</b></td>
                                <td><b>Min.</b></td>
                                <td><b>Max.</b></td>
                                <td><b>Mean</b></td>
                                <td><b>Std. Dev.</b></td>
                                <td><b>Std. Err.</b></td>
                            </tr>
                            {% for field in numericResults.get_field_or_prefix_list() %}
                                {% for condition in range(0,conditionCount+1) %}
                                {% if condition in numericResults.dataDescriptive %}

                                <tr>
                                    <td>{% if lastField and field == lastField %}{% else %}{{ field }}{% endif %}</td>
                                    <td>{{ condition }}</td>
                                    <td>{{ numericResults.dataDescriptive[condition][field].length }}</td>
                                    <td>{{ numericResults.dataDescriptive[condition][field].min | round(3) }}</td>
                                    <td>{{ numericResults.dataDescriptive[condition][field].max | round(3) }}</td>
                                    <td>{{ numericResults.dataDescriptive[condition][field].mean | round(3) }}</td>
                                    <td>{{ numericResults.dataDescriptive[condition][field].std | round(3) }}</td>
                                    <td>{{ numericResults.dataDescriptive[condition][field].sem | round(3) }}</td>
                                </tr>

                                {% set lastField = field %}

                                {% endif %}
                                {% endfor %}
                            {% endfor %}
                        </table>
                    </div>
                </div>

                <div>
                    <div id="chartRadioGrid" style="width: 930px; height: 700px;"></div>
                </div>
            </div>
        </div>
    </div>


{% endblock %}

BOFS/admin/templates/results.html
{% extends "template_admin.html" %}
{% block head %}
{% endblock %}

{% block content %}

    <div class="question padding table-responsive">
        <table class="table table-striped">
            <thead>
            <tr>
                <th scope="col">Questionniare</th>
                <th scope="col">Field</th>
                <th scope="col">Condition</th>
                <th scope="col">N</th>
                <th scope="col">Min.</th>
                <th scope="col">Max.</th>
                <th scope="col">Mean</th>
                <th scope="col">Std. Dev.</th>
                <th scope="col">Std. Err.</th>
            </tr>
            </thead>
            <tbody>
            {% for questionnaire, qresults in results.items() %}
            {% for r in qresults.descriptiveResults %}
            <tr>
                <td>{{questionnaire}}</td>
                <td>{{r.field_name}}</td>
                <td>{{r.condition}}</td>
                <td>{{r.length }}</td>
                <td>{{r.min | round(3)}}</td>
                <td>{{r.max | round(3)}}</td>
                <td>{{r.mean | round(3)}}</td>
                <td>{{r.std | round(3)}}</td>
                <td>{{r.sem | round(3)}}</td>
            </tr>
            {% endfor %}
            {% endfor %}
            </tbody>
        </table>
    </div>

{% endblock %}

BOFS/admin/templates/table_ajax.html
<table class="table table-striped">
    <thead>
    <tr>
        {% for c in columns %}
            {% if c.type in ['integer', 'float'] %}
                <th scope="col" style="text-align: right;">{{ c.name }}</th>
            {% elif c.type == 'boolean' %}
                <th scope="col" style="text-align: center;">{{ c.name }}</th>
            {% else %}
                <th scope="col">{{ c.name }}</th>
            {% endif %}
        {% endfor %}
    </tr>
    </thead>
    <tbody>
    {% for r in rows %}
        <tr>
            {% for c in columns %}
                {% if r[loop.index0] == None %}
                    <td></td>
                {% elif c.type in ['integer', 'float'] %}
                    <td style="text-align: right;">{{ r[loop.index0] }}</td>
                {% elif c.type == 'datetime' %}
                    <td>{{ r[loop.index0].strftime('%Y-%m-%d %H:%M:%S') }}</td>
                {% elif c.type == 'boolean' %}
                    <td style="text-align: center;"><input type="checkbox" disabled
                                                           readonly {{ 'checked' if r[loop.index0] }}></td>
                {% else %}
                    <td>{{ r[loop.index0] }}</td>
                {% endif %}
            {% endfor %}
        </tr>
    {% endfor %}
    </tbody>
</table>

BOFS/admin/templates/template_admin.html
<!DOCTYPE html>
<html>
<head>
    <title>{% block title %}{{ config['TITLE'] }} &mdash; Administration{% endblock %}</title>
    <link href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.9.0/css/all.min.css" integrity="sha256-UzFD2WYH2U1dQpKDjjZK72VtPeWP50NoJjd26rnAdUI=" crossorigin="anonymous" />
    <link rel="stylesheet" href="{{ url_for('BOFS_static', filename='style.css') }}" type="text/css" />

    <script src="https://code.jquery.com/jquery-3.4.1.min.js" integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo=" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>
    {% block head %}{% endblock %}
    <style>
        .table td, .table th {
            padding: .25rem;
            vertical-align: middle;
        }
    </style>
</head>
<body style="padding: 70px 20px 20px 20px;">

    <nav class="navbar navbar-expand-lg fixed-top navbar-dark bg-dark">
        <a class="navbar-brand" href="/">{{ config['TITLE'] }}</a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNavAltMarkup" aria-controls="navbarNavAltMarkup" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarNavAltMarkup">
            <ul class="navbar-nav">
                <li class="nav-item"><a class="nav-link" href="{{ url_for('admin.route_progress') }}">Progress</a></li>

                    {% if logGridClicks %}
                    <li class="nav-item dropdown">
                        <a class="nav-link dropdown-toggle" href="#" data-toggle="dropdown">Export</a>
                        <div class="dropdown-menu">
                            <a class="dropdown-item" href="{{ url_for('admin.route_export') }}">Questionnaire Data</a>
                            <a class="dropdown-item" href="{{ url_for('admin.route_export_item_timing') }}">Grid Timing Data</a>

                        </div>
                    </li>
                    {% else %}
                    <li class="nav-item">
                        <a class="nav-link" href="{{ url_for('admin.route_export') }}">Export</a>
                    </li>
                    {% endif %}

                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" data-toggle="dropdown">Preview Questionnaires</a>
                    <div class="dropdown-menu">
                        <h6 class="dropdown-header">In Use</h6>
                        {% for q in questionnairesLiveUntagged %}
                        <a class="dropdown-item" href="{{ url_for('admin.route_preview_questionnaire', questionnaireName=q) }}">{{ q }}</a>
                        {% endfor %}
                        <div class="dropdown-divider"></div>
                        <h6 class="dropdown-header">In the System</h6>
                        {% for q in questionnairesSystem %}
                        <a class="dropdown-item" href="{{ url_for('admin.route_preview_questionnaire', questionnaireName=q) }}">{{ q }}</a>
                        {% endfor %}
                    </div>
                </li>
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" data-toggle="dropdown">Database Tables</a>
                    <div class="dropdown-menu">
                        {% for t in tableNames %}
                        <a class="dropdown-item" href="{{ url_for('admin.route_table_view', tableName=t) }}">{{ t }}</a>
                        {% endfor %}
                    </div>
                </li>
                <!--li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" data-toggle="dropdown">Questionnaire Results</a>
                    <div class="dropdown-menu">
                        {% for q in questionnairesLive %}
                        <a class="dropdown-item" href="{{ url_for('admin.route_analyze_questionnaire', questionnaireName=q) }}">{{ q }}</a>
                        {% endfor %}
                    </div>
                </li-->
                {% if additionalAdminPages %}
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" data-toggle="dropdown">Custom Pages</a>
                    <div class="dropdown-menu">
                        {% for page in additionalAdminPages %}
                            {% if 'route' in page %}
                            <a class="dropdown-item" href="{{ url_for(page['route']) }}">{{ page['title'] }}</a>
                            {% elif 'url' in page %}
                            <a class="dropdown-item" href="{{ page['url'] }}">{{ page['title'] }}</a>
                            {% else %}
                            <a class="dropdown-item" href="#">{{ page['title'] }}</a>
                            {% endif %}
                        {% endfor %}
                    </div>
                </li>
                {% endif %}
            </ul>
        </div>
    </nav>


{% block content %}
{% endblock %}

</body>
</html>